/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.jiuqi.script.CompileException
 *  com.jiuqi.script.EvalException
 *  com.jiuqi.script.IScriptObject
 *  com.jiuqi.script.Script
 *  com.jiuqi.script.ScriptFactory
 *  com.jiuqi.script.ScriptManager
 *  org.mozilla.javascript.BaseFunction
 *  org.mozilla.javascript.Context
 *  org.mozilla.javascript.Function
 *  org.mozilla.javascript.FunctionObject
 *  org.mozilla.javascript.IdFunctionObject
 *  org.mozilla.javascript.IdScriptableObject
 *  org.mozilla.javascript.JavaScriptException
 *  org.mozilla.javascript.NativeJavaObject
 *  org.mozilla.javascript.RhinoException
 *  org.mozilla.javascript.Scriptable
 *  org.mozilla.javascript.ScriptableObject
 *  org.mozilla.javascript.Undefined
 *  org.mozilla.javascript.UniqueTag
 */
package com.jiuqi.script.rhino;

import com.jiuqi.script.CompileException;
import com.jiuqi.script.EvalException;
import com.jiuqi.script.IScriptObject;
import com.jiuqi.script.Script;
import com.jiuqi.script.ScriptFactory;
import com.jiuqi.script.ScriptManager;
import com.jiuqi.script.rhino.RhinoScriptFactory;
import com.jiuqi.script.rhino.RhinoScriptObject;
import com.jiuqi.script.rhino.ScriptHelper;
import java.lang.reflect.Member;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Calendar;
import java.util.Date;
import org.mozilla.javascript.BaseFunction;
import org.mozilla.javascript.Context;
import org.mozilla.javascript.Function;
import org.mozilla.javascript.FunctionObject;
import org.mozilla.javascript.IdFunctionObject;
import org.mozilla.javascript.IdScriptableObject;
import org.mozilla.javascript.JavaScriptException;
import org.mozilla.javascript.NativeJavaObject;
import org.mozilla.javascript.RhinoException;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;
import org.mozilla.javascript.Undefined;
import org.mozilla.javascript.UniqueTag;

public class RhinoScript
implements Script {
    private Context cx = Context.enter();
    private Scriptable scope = this.cx.initStandardObjects(null, false);

    static {
        ScriptManager.registerScriptFactory((ScriptFactory)new RhinoScriptFactory());
    }

    public RhinoScript() {
        this.regDefaultFunction();
        Context.exit();
    }

    public Object evaluate(String script, String sourceName) throws CompileException, EvalException {
        this.cx = Context.enter();
        try {
            Object result = this.cx.evaluateString(this.scope, script, sourceName, 1, null);
            Object object = this.convertObject(result);
            return object;
        }
        catch (JavaScriptException e) {
            throw new EvalException(e.getMessage(), e.sourceName(), e.lineNumber(), e.columnNumber(), (Throwable)e);
        }
        catch (RhinoException e) {
            throw new CompileException(e.getMessage(), e.sourceName(), e.lineNumber(), e.columnNumber(), (Throwable)e);
        }
        finally {
            Context.exit();
        }
    }

    public Object call(String name, Object[] args) throws NoSuchMethodException, CompileException, EvalException {
        Object[] param = args;
        if (param == null) {
            param = new Object[]{};
        }
        this.convertArgument(param);
        this.cx = Context.enter();
        try {
            Function fun = this.getFunctionFromScope(this.scope, name);
            if (fun != null) {
                Object result = fun.call(this.cx, this.scope, (Scriptable)fun, param);
                Object object = this.convertObject(result);
                return object;
            }
            try {
                throw new NoSuchMethodException("没有该函数:" + name);
            }
            catch (JavaScriptException e) {
                throw new EvalException(e.getMessage(), e.sourceName(), e.lineNumber(), e.columnNumber(), (Throwable)e);
            }
            catch (RhinoException e) {
                throw new CompileException(e.getMessage(), e.sourceName(), e.lineNumber(), e.columnNumber(), (Throwable)e);
            }
        }
        finally {
            Context.exit();
        }
    }

    public void compile(String script, String sourceName) throws CompileException {
        this.cx = Context.enter();
        try {
            try {
                this.cx.evaluateString(this.scope, script, sourceName, 1, null);
            }
            catch (RhinoException e) {
                throw new CompileException(e.getMessage(), e.sourceName(), e.lineNumber(), e.columnNumber(), (Throwable)e);
            }
        }
        finally {
            Context.exit();
        }
    }

    public Object get(String name) {
        Object o = this.getValueFromScope(this.scope, name);
        if (o instanceof UniqueTag || o instanceof Undefined) {
            return null;
        }
        return o;
    }

    public void put(String name, Object value) {
        this.putValueToScope(this.scope, name, value);
    }

    public Object toJava(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof RhinoScriptObject) {
            return ((RhinoScriptObject)((Object)obj)).getScriptObject();
        }
        if (!(obj instanceof IdScriptableObject)) {
            return obj;
        }
        IdScriptableObject result = (IdScriptableObject)obj;
        if (result.getClassName().equals("Date")) {
            IdFunctionObject v = (IdFunctionObject)ScriptableObject.getProperty((Scriptable)result, (String)"getTime");
            Object m = result.execIdCall(v, Context.getCurrentContext(), this.scope, (Scriptable)result, null);
            long millis = ((Double)m).longValue();
            Calendar c = Calendar.getInstance();
            c.setTimeInMillis(millis);
            return c;
        }
        return result;
    }

    public Object toScript(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof IScriptObject) {
            return new RhinoScriptObject((IScriptObject)obj);
        }
        if (obj instanceof IdScriptableObject) {
            return obj;
        }
        if (obj instanceof NativeJavaObject) {
            Object result = ((NativeJavaObject)obj).unwrap();
            if (result instanceof IScriptObject) {
                return new RhinoScriptObject((IScriptObject)result);
            }
            if (result instanceof Calendar) {
                Calendar c = (Calendar)result;
                return Context.getCurrentContext().newObject(this.scope, "Date", new Object[]{new Long(c.getTimeInMillis())});
            }
            if (result instanceof Date) {
                Date d = (Date)result;
                return Context.getCurrentContext().newObject(this.scope, "Date", new Object[]{new Long(d.getTime())});
            }
        }
        return obj;
    }

    /*
     * Unable to fully structure code
     */
    private Function getFunctionFromScope(Scriptable scope, String name) {
        parentName = name;
        parent = scope;
        if (name != null) ** GOTO lbl10
        return null;
lbl-1000:
        // 1 sources

        {
            o = parent.get(parentName = parentName.substring(0, name.indexOf(".")), scope);
            if (!(o instanceof Scriptable)) {
                return null;
            }
            parent = (Scriptable)o;
            name = name.substring(name.indexOf(".") + 1);
lbl10:
            // 2 sources

            ** while (name.indexOf((String)".") != -1)
        }
lbl11:
        // 1 sources

        o = parent.get(name, scope);
        if (o instanceof Function) {
            return (Function)o;
        }
        return null;
    }

    /*
     * Unable to fully structure code
     */
    private Object getValueFromScope(Scriptable scope, String name) {
        parentName = name;
        parent = scope;
        if (name != null) ** GOTO lbl10
        return null;
lbl-1000:
        // 1 sources

        {
            o = parent.get(parentName = parentName.substring(0, name.indexOf(".")), scope);
            if (!(o instanceof Scriptable)) {
                return null;
            }
            parent = (Scriptable)o;
            name = name.substring(name.indexOf(".") + 1);
lbl10:
            // 2 sources

            ** while (name.indexOf((String)".") != -1)
        }
lbl11:
        // 1 sources

        return parent.get(name, scope);
    }

    /*
     * Unable to fully structure code
     */
    private void putValueToScope(Scriptable scope, String name, Object value) {
        parentName = name;
        parent = scope;
        if (name != null) ** GOTO lbl10
        return;
lbl-1000:
        // 1 sources

        {
            o = parent.get(parentName = parentName.substring(0, name.indexOf(".")), scope);
            if (!(o instanceof Scriptable)) {
                return;
            }
            parent = (Scriptable)o;
            name = name.substring(name.indexOf(".") + 1);
lbl10:
            // 2 sources

            ** while (name.indexOf((String)".") != -1)
        }
lbl11:
        // 1 sources

        if (value instanceof IScriptObject) {
            parent.put(name, scope, (Object)new RhinoScriptObject((IScriptObject)value));
        } else {
            parent.put(name, scope, value);
        }
    }

    private void convertArgument(Object[] args) {
        if (args == null) {
            return;
        }
        int i = 0;
        while (i < args.length) {
            if (args[i] instanceof Calendar) {
                Calendar c = (Calendar)args[i];
                args[i] = this.cx.newObject(this.scope, "Date", new Object[]{new Long(c.getTimeInMillis())});
            }
            ++i;
        }
    }

    private Object convertObject(Object result) {
        if (result instanceof ScriptableObject) {
            ScriptableObject o = (ScriptableObject)result;
            if (o.getClassName().equals("CustomScriptObject")) {
                return ((RhinoScriptObject)o).getScriptObject();
            }
            if (o.getClassName().equals("Date")) {
                BaseFunction v = (BaseFunction)ScriptableObject.getProperty((Scriptable)o, (String)"getTime");
                Object m = v.call(this.cx, this.scope, (Scriptable)o, null);
                long millis = ((Double)m).longValue();
                Calendar c = Calendar.getInstance();
                c.setTimeInMillis(millis);
                return c;
            }
            return o;
        }
        if (result instanceof NativeJavaObject) {
            Object o = ((NativeJavaObject)result).unwrap();
            return o;
        }
        return result;
    }

    private void regDefaultFunction() {
        if (this.scope == null) {
            return;
        }
        Class<ScriptHelper> c = ScriptHelper.class;
        ScriptHelper u = new ScriptHelper(this.scope);
        Method[] methods = c.getDeclaredMethods();
        int i = 0;
        while (i < methods.length) {
            if (!methods[i].getName().equals("getClassName") && Modifier.isPublic(methods[i].getModifiers())) {
                this.scope.put(methods[i].getName(), this.scope, (Object)new FunctionObject(methods[i].getName(), (Member)methods[i], (Scriptable)u));
            }
            ++i;
        }
    }
}

